<?php
namespace Neklo\Scheduler\Controller\Adminhtml\Job;

use Neklo\Scheduler\Controller\Adminhtml;
use Neklo\Scheduler\Api\Data\JobInterface;

class Save extends Adminhtml\Action
{
    const REDIRECT_URL = '*/index/jobs';

    public function execute()
    {
        $redirectBack = $this->getRequest()->getParam('back', false);
        $data = $this->getRequest()->getParams();
        $id = $data[JobInterface::JOB_ID];

        try {
            if ($id) {
                /* @var $model \Neklo\Scheduler\Model\Job */
                $model = $this->_objectManager
                    ->create('Neklo\Scheduler\Model\Job');
                $model->load($id);
                if ($model->getId()) {
                    $model->setData($data)->save();
                    $name = $model->getJobCode();
                    $this->messageManager->addSuccess(
                        __('Schedule %1 saved', $name));
                }
            } else {
                $this->messageManager->addError(__('Data ID missing - error'));
            }
        } catch (\Exception $e) {
            $this->log->critical($e->getMessage());
            $this->messageManager->addError(__('Operation error'));
            $this->_session->setFormData($data);
            return $this->_redirect('*/job/edit', ['id' => $id, 'back' => null, '_current' => true]);
        }
        return $this->_redirect(static::REDIRECT_URL);
    }
}
