<?php
namespace Neklo\Scheduler\Controller\Adminhtml;

abstract class Operation extends Action
{
    const REDIRECT_URL = '*/index/index';

    /**
     *
     * @var \Psr\Log\LoggerInterface
     */
    protected $log;

    /**
     *
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\Registry $registry
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Registry $registry,
        \Psr\Log\LoggerInterface $logger
    ) {
        $this->log = $logger;
        parent::__construct($context, $resultPageFactory, $registry);
    }

    protected function _isAllowed()
    {
        return $this->_authorization
            ->isAllowed('Neklo_Scheduler::edit');
    }
}
